Subject: Re: [PATCH] Add Support for Freescale FlexCAN CAN controller

From: Oliver Hartkopp <[email-masked]>
Date: Mon, 27 Jul 2009 12:52:37 +0200

Wolfgang Grandegger wrote:
> Oliver Hartkopp wrote:
>> Wolfgang Grandegger wrote:
>>> Sascha Hauer wrote:
>>>> On Fri, Jul 24, 2009 at 04:55:02PM +0200, Wolfgang Grandegger wrote:
>>
>>> [...]
>>>>>> +	kfree_skb(skb);
>>>>> Support for echo skb using can_put/get_echo_skb() is missing. It should
>>>>> not be a big deal to add it.
>>>> In fact it's not missing, but the hardware is configured to receive its
>>>> own packets, so this isn't needed.
>>> But the user may disable IFF_ECHO, which should be handled somehow.
>> Really?
>>
>> IMO IFF_ECHO indicates the capability of the network driver to perform the MAC
>> layer frame echo on driver level.
>>
>> Only when you have a CAN driver that does not have this capability (the 'bad'
>> non default case) this flag is cleared.
>>
>> There is no need to provide a mode that can switch this functionality 'on' and
>> 'off'. IFF_ECHO is just an indication provided by the driver.
>>
>> When the FlexCAN controller can 'receive' a sent frame, so that it reflects
>> the correct message order on the bus, this is perfect.
>>
>> In this case Sascha should set the IFF_ECHO flag and he's done.
> 
> I thought the user can toggle the IFF_ECHO flag with the "ip" utility,
> but obviously I'm wrong.

AFAIK the only driver that currently allows to switch this flag is the vcan
driver - but this is for testing purposes only and can be configured by the
module commandline.

I assume having the echo functionality runtime configurable is only effort and
complicates the driver ...

Best regards,
Oliver